﻿using BizTracker2015.WebApp.Data;
using BizTracker2015.WebApp.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BizTracker2015.WebApp.Controllers
{
    public class SettingsController : Controller
    {

      private BTConfigEntities context = new BTConfigEntities();

        // GET: Settings
        public ActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public JsonResult getValues()
        {
          var model = DataStorageHelper.GetValues();
          return Json(model, JsonRequestBehavior.AllowGet);

        }

        [HttpPost]
        public void setValue(string key, string value)
        {
          DataStorageHelper.SetValue(key, value);
        }
    }
}