﻿app.controller('ContactCtrl', function ($scope, $http, $location) {
  $scope.clara = "cute";
  $scope.errorMessage = "";
  $scope.loadMode = false;
  $scope.params = {};
  $scope.param = {};

  $scope.getCorrectApplicationPath = function () {
    var splitArray = $location.absUrl().split('/');
    console.log("Split..");
    console.dir(splitArray);
    return "http://" + splitArray[2] + "/" + splitArray[3] + "/";
  };

  $scope.path = $scope.getCorrectApplicationPath();

  //$scope.f = function (url) {
  //  return url + "f";
  //};

  $scope.updateValue = function () {
    var selectedParam = this.param;
   // console.dir(selectedParam);
    $scope.setValue(selectedParam);

  };

  $scope.getValues = function () {
    var url = "Settings/getValues";
    var method = "GET";
    $scope.loadMode = true;
    $http(
      { method: "GET", url: $scope.path + url }
      ).success(function (data) {
        console.dir(data);
        $scope.params = data;
        $scope.loadMode = false;
      })
    .error(function (data) { console.dir(data); $scope.loadMode = false;});
  };


  $scope.setValue = function (pParam) {
    var url = "Settings/setValue";
    var method = "POST";
    console.log("SetValue");
    $scope.loadMode = true;
    $http({
      method: method,
      url: $scope.path + url,
      data: { key: pParam.Key, value: pParam.Value }
    })
    .success(function (data) {
      $scope.loadMode = false;
      $scope.getValues();
    })
    .error(function (data) {
      $scope.loadMode = false;
      console.log("Error");
      console.dir(data);
    });
  };

  //Init
  $scope.getValues();




 

});