﻿
Date.prototype.beginningofDay = function () {

  var yyyy = this.getFullYear().toString();
  var MM = (this.getMonth() + 1).toString(); // getMonth() is zero-based         
  var dd = this.getDate().toString();
  var hh = this.getHours().toString();
  var mm = this.getMinutes().toString();
  var ss = this.getSeconds().toString();
  return yyyy + '-' + (MM[1] ? MM : "0" + MM[0]) + '-' + (dd[1] ? dd : "0" + dd[0]) + ' 00:00:00';
};

Date.prototype.beginningofDayYearAgo = function () {

  var yyyy = (this.getFullYear() - 1).toString();
  var MM = (this.getMonth() + 1).toString(); // getMonth() is zero-based         
  var dd = this.getDate().toString();
  var hh = this.getHours().toString();
  var mm = this.getMinutes().toString();
  var ss = this.getSeconds().toString();
  return yyyy + '-' + (MM[1] ? MM : "0" + MM[0]) + '-' + (dd[1] ? dd : "0" + dd[0]) + ' 00:00:00';
};

Date.prototype.beginningofDayYearAgoNoTime = function () {

  var yyyy = (this.getFullYear() - 1).toString();
  var MM = (this.getMonth() + 1).toString(); // getMonth() is zero-based         
  var dd = this.getDate().toString();
  var hh = this.getHours().toString();
  var mm = this.getMinutes().toString();
  var ss = this.getSeconds().toString();
  return yyyy + '-' + (MM[1] ? MM : "0" + MM[0]) + '-' + (dd[1] ? dd : "0" + dd[0]);
};

Date.prototype.startOfDay7DaysAgo = function () {

  var yyyy = this.getFullYear().toString();
  var MM = (this.getMonth() + 1).toString(); // getMonth() is zero-based         
  var dd = (this.getDate() -7).toString();
  var hh = this.getHours().toString();
  var mm = this.getMinutes().toString();
  var ss = this.getSeconds().toString();
  return yyyy + '-' + (MM[1] ? MM : "0" + MM[0]) + '-' + (dd[1] ? dd : "0" + dd[0]) + ' 00:00:00';
};


Date.prototype.endofDay = function () {

  var yyyy = this.getFullYear().toString();
  var MM = (this.getMonth() + 1).toString(); // getMonth() is zero-based         
  var dd = this.getDate().toString();
  var hh = this.getHours().toString();
  var mm = this.getMinutes().toString();
  var ss = this.getSeconds().toString();
  return yyyy + '-' + (MM[1] ? MM : "0" + MM[0]) + '-' + (dd[1] ? dd : "0" + dd[0]) + ' 23:59:59';
};

app.controller('BTTRCtrl', function ($scope, $http, $modal, $log, $location) {


  //DateTimePickers


  //$scope.dateFrom = new Date().beginningofDayYearAgoNoTime();
  // $scope.dateTo = new Date().endofDay();


  $scope.hourStep = 1;
  $scope.minuteStep = 15;




  //DateTimePickers (end)


    $scope.resultCount = 0;
    $scope.errorMessage = "";
    $scope.smallerrorMessage = "";
  $scope.Clara = "Cute!";
  $scope.top = 10;
  $scope.portName = "";
  $scope.errorOnly = false;
  $scope.globalSearch = false;
  $scope.fromTime = "00:00";
  $scope.toTime = "23:59";

  $scope.messageType = "";
  $scope.customProperties = [];
  $scope.propertyValues = ['', '', '']; //Array of values in the Custom Properties
  $scope.parameters = {};

  //
  $scope.allDates = false;
  var date = new Date();
  var dateBack = date.setDate(date.getDate() - 1);
  $scope.dateFrom = new Date(dateBack);
  // $scope.dateFrom = new Date(2014, 1, 1);
  $scope.dateTo = new Date();


  $scope.loadMode = false;
  $scope.tempMessageID = "8564F484-267A-4EA5-95D6-0B0D069EB3C9";
  $scope.instances = [];
  $scope.contextList = [];

  $scope.open = function ($event) {
    $event.preventDefault();
    $event.stopPropagation();

    $scope.opened = true;
  };


  $scope.open2 = function ($event) {
    $event.preventDefault();
    $event.stopPropagation();

    $scope.opened2 = true;
  };

  $scope.datepickerOptions = {
    format: 'yyyy-mm-dd',
    language: 'fr',
    autoclose: true,
    weekStart: 0,
  };

  $scope.getCorrectApplicationPath = function () {
    var splitArray = $location.absUrl().split('/');
    console.log("Split..");
    console.dir(splitArray);
    return "http://" + splitArray[2] + "/" + splitArray[3] + "/";
  };

  $scope.path = $scope.getCorrectApplicationPath();


  $scope.translateError = function(rawError)
  {
    //var reg = new RegExp("(?<title>).*?(?</title>)");
    //var result = reg.exec(rawError);
    var result = "Morten";
    return result;
  }

  $scope.loadParameters = function () {
    var url = $scope.path + "Common/GetParameters";

    $http({ method: "GET", url: url })
      .success(function (data) {
        console.log("params fetched");
        console.dir(data);
        $scope.parameters = data;
      })
      .error(function (data) { });
    
  }; //End loadParameters


  $scope.reset = function () {
    var date = new Date();
    var dateBack = date.setDate(date.getDate() - 1);
    $scope.dateFrom = new Date(dateBack);
    // $scope.dateFrom = new Date(2014, 1, 1);
    $scope.dateTo = new Date();

    $scope.top = 10;
    $scope.fromTime = "00:00";
    $scope.toTime = "23:59";
    $scope.globalSearch = false;
    $scope.errorOnly = false;
    $scope.allDates = false;

  };

  $scope.getCustomProperties = function () {
    var url = $scope.path + "Common/GetCustomProperties";

    $http({ method: "GET", url: url }).
      success(function (data) {
        $scope.customProperties = data;
        //$scope.propertyValues = data;

        //for (index = 0; index < $scope.propertyValues.length; ++index) {
        //  $scope.propertyValues[index] = '';
        //}
        //console.dir(data);
      }).
      error(function (data) { $scope.errorMessage = data;});
  };

  //button clear
  $scope.clear = function () {
    $scope.propertyValues = ['', '', '']; //Array of values in the Custom Properties
    $scope.portName = "";
    $scope.messageType = "";
    $scope.instances = [];
    $scope.reset();
  };

  //button update
  $scope.update = function () {
    console.dir($scope.propertyValues);
    $scope.updateInstances();
  };


  $scope.updateInstancesWithIDS = function (instanceID, activityID) {
    $scope.loadMode = true;
    var url = $scope.path + "Track/GetInstance";

    $http({
      method: "GET",
      url:  url,
      params: {
        instanceId: instanceID,
        activityId: activityID,
        customProperties: $scope.propertyValues
      }

    }).
      success(function (data, status, headers, config) {
  
        $scope.instances = data;
        $scope.loadMode = false;

      }).
      error(function (data, status, headers, config) {
        //console.dir(data);
        console.dir(status);
           console.dir(headers);
           console.dir(config);

        $scope.loadMode = false;
        $scope.errorMessage = data;
      });

  }


  $scope.follow = function (instanceID, activityID) {
    console.log(instanceID + ", " + activityID);
    $scope.updateInstancesWithIDS(instanceID, activityID);
  }

  $scope.back = function (instanceID, activityID) {
    console.log(instanceID + ", " + activityID);
    $scope.updateInstancesWithIDS(instanceID, activityID);
  };


  $scope.updateInstances = function () {
    $scope.errorMessage = "";
    $scope.loadMode = true;

    console.log($scope.dateFrom);
   console.log($scope.dateTo);

   // return;
   console.log("Starting call2");
   var url = $scope.path + "Track/GetInstances";
 //  console.log(url);
   $http.get(url,{
     params: {
       top: $scope.top,
       dtStart: $scope.dateFrom,
       dtStop: $scope.dateTo,
       allDates: $scope.allDates,
       portName: $scope.portName,
       messageType: $scope.messageType,
       errorOnly: $scope.errorOnly,
       customProperties: $scope.propertyValues,
       receiveOnly: !$scope.globalSearch,
       fromTime: $scope.fromTime,
       toTime: $scope.toTime
     },
     cache:false
   }).
   then(function (response) {
     //(console.log(data);
     $scope.instances = response.data;
     $scope.loadMode = false;
   }, function (errorData) {
     console.log(errorData);
     $scope.errorMessage = errorData.data.Message;
     $scope.loadMode = false;
   });
//        success(function (data) {
//          console.log("Back with success");
//          console.log(data);


////          console.dir(data);
//          $scope.instances = data;
//          $scope.loadMode = false;
//          $scope.resultCount = data.length;

//        }).
//        error(function (data, status, headers, config) {
//          console.log("Back with error");

//          console.dir(data);
//          console.dir(status);
//          console.dir(headers);
//          console.dir(config);

//          $scope.loadMode = false;
//          $scope.errorMessage = data;
//          $scope.smallerrorMessage = $scope.translateError(data);
//          console.log($scope.smallerrorMessage);
//        });
  };

  $scope.showContext = function (messageID) {
    // console.log(messageID);
    $scope.loadMode = true;

    var url = $scope.path + "Track/GetMessageContext";

    $http({ method: "GET", url: url, params: { messageID: messageID } }).
        success(function (data) {
          //console.dir(data);
          $scope.loadMode = false;

          $scope.contextList = data;
          var modalInstance = $modal.open({
            templateUrl: 'showMessageContextModal.html',
            controller: 'showMessageContextCtrl',
            size: 'lg',
            resolve: {
              contextList: function () {
                return data;
              },
              messageID: function () { return messageID; }
            }
          });
        }).
        error(function (data) {
          $scope.loadMode = false;

        });
  };

  $scope.all = false;

  $scope.showMessage = function (messageID, size,messageName) {
    $scope.loadMode = true;
    var msgID = messageID;
    $scope.all = false; 
    var url = $scope.path + "Track/GetMessageBody";

    $http({ method: "GET", url: url, params: { messageID: msgID, all: $scope.all } }).
        success(function (data) {
          //console.dir(data);
          $scope.loadMode = false;
          var modalInstance = $modal.open({
            templateUrl: 'showMessageModal.html',
            controller: 'showMessageCtrl',
            windowClass: 'app-modal-window',
            size: size,
            resolve: {
              message: function () {
                return data;
              },
              messageID: function () { return msgID; },
              messageName: function () { return messageName;}
            }
          });
        }).
        error(function (data) {
          $scope.loadMode = false;
          $scope.errorMessage = data;
        });



  };

//On first
  $scope.getCustomProperties();
  $scope.loadParameters();

});

app.controller('showMessageCtrl', function ($scope, $http, $modalInstance, $location, message, messageID, messageName) {
  $scope.message = message;
  $scope.isCollapsed = true;
  $scope.messageContext = [];
  $scope.messageID = messageID;
  $scope.messageName = messageName;
  $scope.loading = false;
  $scope.indented = false; 

  $scope.indent = function () {
    console.log("indenting..!");

    $http({ method: "GET", url: $scope.path + "Common/IndentByMessageID", params: { messageID: $scope.messageID } })
      .success(function (data) {
        console.dir(data);
        //$scope.message = data;
        $scope.indented = ($scope.message.Body != data);
        $scope.message.Body = data;
      })
    .error(function (data) {
      console.dir(data);
    });


  };

  $scope.getCorrectApplicationPath = function () {
    var splitArray = $location.absUrl().split('/');
    console.log("Split..");
    console.dir(splitArray);
    return "http://" + splitArray[2] + "/" + splitArray[3] + "/";
  };

  $scope.path = $scope.getCorrectApplicationPath();

  $scope.getContext = function () {
    //console.log("getting Context of message: " + $scope.messageID);
    var url = $scope.path + "Track/GetMessageContext";

    $http({
      method: "GET",
      url: url,
      params: {messageID:$scope.messageID}
  })
  .success(function (data) {
   // console.log("GetMessageContext success");
    // console.dir(data);
    $scope.messageContext = data; 
  })
  .error(function(data){});
  };


  $scope.indent_old = function () {
    console.dir($scope.message);
    var firstPath = $location.absUrl();

    $http({ method: "GET", url: "Common/Indent", params: { text: $scope.message.Body } })
      .success(function (data) {
        console.dir(data);
        //$scope.message = data;
        $scope.indented = ($scope.message.Body != data);
        $scope.message.Body = data;
      })
    .error(function (data) {
      console.dir(data);
    });


  };


  //redundant!!
  $scope.all = function () {
    var firstPath = $location.absUrl();

    $scope.loading = true;
    $http({ method: "GET", url: "Track/GetMessageBody", params: { messageID: $scope.messageID, all: true } }).
          success(function (data) {
            //console.dir(data);
            $scope.message = data;
            $scope.loading = false;

          }).
          error(function (data) {
            console.log("ERROR!!!");
            console.dir(data);
            $scope.loading = false;

          });
  };
  //redundant

  $scope.save = function () {
    console.log("Saving messageID: " + $scope.messageID);
    var method = "GET";
    var url = $scope.path + "Track/SaveMessage";

    $http({ method: method, url: url, params: { messageID: $scope.messageID } })
      .success(function (data) {
        console.log("Success saved!!");
        console.dir(data);

      })
      .error(function (data) {
        console.log("Error saved!!");
        console.dir(data);



      });

  };

  $scope.ok = function () {

    $modalInstance.close();
  };

  //call on init
  $scope.getContext();
});

app.controller('showMessageContextCtrl', function ($scope, $modalInstance, contextList, messageID) {
 

  $scope.ContextList = contextList;
  $scope.messageID = messageID;

  $scope.ok = function () {
    $modalInstance.close();
  };
});
