﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace BizTracker2015.WebApp
{
  public class RouteConfig
  {
    public static void RegisterRoutes(RouteCollection routes)
    {
      routes.IgnoreRoute("{resource}.axd/{*pathInfo}");


      //routes.MapRoute(
      //     name: "Instance",
      //     url: "{controller}/{action}/{instanceID}",
      //               defaults: new { controller = "Instance", action = "Details", instanceID = UrlParameter.Optional }

      //     );
      routes.MapRoute(
         name: "InstanceDetails",
         url: "Instance/Details/{instanceID}/{activityID}",
         defaults: new { controller = "Instance", action="Details"}
     );


      routes.MapRoute(
          name: "Default",
          url: "{controller}/{action}/{id}",
          defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
      );
    }
  }
}
